from aclc_ba.morphology.bw_solutions import BwSolution


def test_bw_solutoins_with_list() -> None:
    passed_tokenized_list = ["في", "استفتاء", "ضمني", "علي", "رئاسة", "بوش", ":"]
    expected_words_solutions_list = [
        [
            {
                "word": "في",
                "lemmaid": "fiy",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "fiy",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PREP",
                "stem_Pattern": "",
            },
            {
                "word": "في",
                "lemmaid": "fiy",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "fiy",
                "suf1": "~a/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PREP",
                "stem_Pattern": "",
            },
            {
                "word": "في",
                "lemmaid": "fiy",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Viy",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "ABBREV",
                "stem_Pattern": "",
            },
            {
                "word": "في",
                "lemmaid": "y",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "y",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "brq",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "ABBREV",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "استفتاء",
                "lemmaid": "{isotifotA'",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "{isotifotA'",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "ftw/fty",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
            {
                "word": "استفتاء",
                "lemmaid": "{isotifotA'",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "{isotifotA'",
                "suf1": "F/NOUN",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "ftw/fty",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
            {
                "word": "استفتاء",
                "lemmaid": "{isotifotA'",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "{isotifotA'",
                "suf1": "F/NOUN",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "ftw/fty",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "ضمني",
                "lemmaid": "Dimoniy~",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimoniy~",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmn",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "ADJ",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dimon",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimon",
                "suf1": "iy/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmn",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN_ADV(P)",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dimon",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimon",
                "suf1": "iy/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmn",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dam~-u",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dam~",
                "suf1": "a/PVSUFF_SUBJ:3MS",
                "suf2": "niy/PVSUFF_DO:1S",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmm",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PV",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "علي",
                "lemmaid": "EalaY",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Ealay",
                "suf1": "~a/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PREP",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "Ealiy~",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Ealiy~",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Ely",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "ADJ",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "Ealiy~",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Ealiy~",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Ely",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN_PROP",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "Eal~a",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Eal~a",
                "suf1": "iy/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "SUB_CONJ",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "Eal~aY",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Eal~",
                "suf1": "iy/CVSUFF_SUBJ:2FS",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Elw/Ely",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "CV",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "EalaY",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "EalaY",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PREP",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "رئاسة",
                "lemmaid": "ri}Asap",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "ri}As",
                "suf1": "ap/NSUFF",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "r's",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
            {
                "word": "رئاسة",
                "lemmaid": "ri}Asap",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "ri}As",
                "suf1": "ap/NSUFF",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "r's",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "بوش",
                "lemmaid": "buw$",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "buw$",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN_PROP",
                "stem_Pattern": "",
            },
            {
                "word": "بوش",
                "lemmaid": "baw~a$",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "baw~a$",
                "suf1": "a/PVSUFF_SUBJ:3MS",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "bw$",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PV",
                "stem_Pattern": "",
            },
            {
                "word": "بوش",
                "lemmaid": "bawo$",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "bawo$",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "bw$",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": ":",
                "lemmaid": "",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": ":",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "Punc",
                "stem_Pattern": "",
            }
        ],
    ]
    bw = BwSolution()
    result_words_analysis = bw.analyze_words_bw(passed_tokenized_list)
    assert result_words_analysis == expected_words_solutions_list


def test_bw_solutoins_with_word() -> None:
    passed_word = "ضمني"
    expected_word_solutions_list = [
        [
            {
                "word": "ضمني",
                "lemmaid": "Dimoniy~",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimoniy~",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmn",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "ADJ",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dimon",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimon",
                "suf1": "iy/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmn",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN_ADV(P)",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dimon",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimon",
                "suf1": "iy/POSS_PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmn",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dam~-u",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dam~",
                "suf1": "a/PVSUFF_SUBJ:3MS",
                "suf2": "niy/PVSUFF_DO:1S",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "Dmm",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PV",
                "stem_Pattern": "",
            },
        ]
    ]
    bw = BwSolution()
    result_words_analysis = bw.analyze_words_bw(passed_word)
    assert result_words_analysis == expected_word_solutions_list
