from aclc_ba.morphology.db_analyzer_based import DbAnalyzedBased


def test_db_solutoins_with_list() -> None:
    passed_tokenized_list = ["في", "استفتاء", "ضمني", "علي", "رئاسة", "بوش", ":"]
    expected_words_solutions_list = [
        [
            {
                "word": "في",
                "lemmaid": "fiy",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "fiy",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "في",
                "root": "",
                "tag_statistics": "-0.0001281312065306",
                "lemma_statistics": "-0.0001281312065306",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PREP",
                "stem_Pattern": "",
            },
            {
                "word": "في",
                "lemmaid": "",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "fiy",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "في",
                "root": "",
                "tag_statistics": "-8.962519832949532",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "ABBREV",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "استفتاء",
                "lemmaid": "{isotifotA'",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "{isotifotA'",
                "suf1": "",
                "suf2": "",
                "gen": "MASC",
                "num": "SG",
                "arabic_stem": "استفتاء",
                "root": "ftw/fty",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            }
        ],
        [
            {
                "word": "ضمني",
                "lemmaid": "Dimoniy~",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dimoniy~",
                "suf1": "",
                "suf2": "",
                "gen": "MASC",
                "num": "SG",
                "arabic_stem": "ضمنيّ",
                "root": "Dmn",
                "tag_statistics": "-0.2231435513142097",
                "lemma_statistics": "-0.2231435513142097",
                "tag_lemma_statistics": "-0.2876820724517809",
                "stems": "",
                "tags": "ADJ",
                "stem_Pattern": "",
            },
            {
                "word": "ضمني",
                "lemmaid": "Dam~-u",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Dam~",
                "suf1": "a/PVSUFF_SUBJ:3MS",
                "suf2": "niy/PVSUFF_DO:1S",
                "gen": "",
                "num": "",
                "arabic_stem": "ضمّ",
                "root": "Dmm",
                "tag_statistics": "-1.6094379124341005",
                "lemma_statistics": "-1.6094379124341005",
                "tag_lemma_statistics": "-1.758815313508701",
                "stems": "",
                "tags": "PV",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "علي",
                "lemmaid": "Ealiy~",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Ealiy~",
                "suf1": "",
                "suf2": "",
                "gen": "MASC",
                "num": "SG",
                "arabic_stem": "عليّ",
                "root": "Elw/Ely",
                "tag_statistics": "-0.1574240051722275",
                "lemma_statistics": "-0.1574240051722275",
                "tag_lemma_statistics": "-0.0093023926623135",
                "stems": "",
                "tags": "NOUN_PROP",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "EalaY",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Ealay",
                "suf1": "~a/PRON_1S",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "علي",
                "root": "",
                "tag_statistics": "-1.9459101490553128",
                "lemma_statistics": "-1.9459101490553128",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "PREP",
                "stem_Pattern": "",
            },
            {
                "word": "علي",
                "lemmaid": "Eal~aY",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Eal~",
                "suf1": "iy/CVSUFF_SUBJ:2FS",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "علّ",
                "root": "Elw/Ely",
                "tag_statistics": "-5.877735781779639",
                "lemma_statistics": "-5.877735781779639",
                "tag_lemma_statistics": "-0.6931471805599453",
                "stems": "",
                "tags": "CV",
                "stem_Pattern": "",
            },
        ],
        [
            {
                "word": "رئاسة",
                "lemmaid": "ri}Asap",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "ri}As",
                "suf1": "ap/NSUFF",
                "suf2": "",
                "gen": "FEM",
                "num": "SG",
                "arabic_stem": "رئاس",
                "root": "r's",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN",
                "stem_Pattern": "",
            }
        ],
        [
            {
                "word": "بوش",
                "lemmaid": "buw$",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "buw$",
                "suf1": "",
                "suf2": "",
                "gen": "MASC",
                "num": "SG",
                "arabic_stem": "بوش",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "NOUN_PROP",
                "stem_Pattern": "",
            }
        ],
        [
            {
                "word": ":",
                "lemmaid": "",
                "pr1": "",
                "pr2": "",
                "pr3": "",
                "stem": "Punc",
                "suf1": "",
                "suf2": "",
                "gen": "",
                "num": "",
                "arabic_stem": "",
                "root": "",
                "tag_statistics": "0.0",
                "lemma_statistics": "0.0",
                "tag_lemma_statistics": "0.0",
                "stems": "",
                "tags": "",
                "stem_Pattern": "",
            }
        ],
    ]
    db = DbAnalyzedBased()
    result_words_analysis = db.analyze_words(passed_tokenized_list)
    assert result_words_analysis == expected_words_solutions_list


def test_db_solutoins_with_list() -> None:
    passed_word = "الديمقراطيين"
    expected_analysis = [
        {
            "word": "الديمقراطيين",
            "lemmaid": "diymuqrATiy~",
            "pr1": "Al/DET",
            "pr2": "",
            "pr3": "",
            "stem": "diymuqrATiy~",
            "suf1": "iyna/NSUFF",
            "suf2": "",
            "gen": "MASC",
            "num": "PL",
            "arabic_stem": "ديمقراطيّ",
            "root": "",
            "tag_statistics": "-0.0571584138399486",
            "lemma_statistics": "0.0",
            "tag_lemma_statistics": "-1.1769441319380167",
            "stems": "",
            "tags": "NOUN",
            "stem_Pattern": "",
        },
        {
            "word": "الديمقراطيين",
            "lemmaid": "diymuqrATiy~",
            "pr1": "Al/DET",
            "pr2": "",
            "pr3": "",
            "stem": "diymuqrATiy~",
            "suf1": "iyna/NSUFF",
            "suf2": "",
            "gen": "MASC",
            "num": "PL",
            "arabic_stem": "ديمقراطيّ",
            "root": "",
            "tag_statistics": "-2.890371757896165",
            "lemma_statistics": "0.0",
            "tag_lemma_statistics": "-0.368486104867077",
            "stems": "",
            "tags": "ADJ",
            "stem_Pattern": "",
        },
    ]
    db = DbAnalyzedBased()
    result_word_analysis = db.analyze(passed_word)
    assert result_word_analysis == expected_analysis
